<?php
/*
  $Id: cm_sc_shipping.php
  $Loc: catalog/includes/modules/content/shopping_cart/

  Ship In Cart 6.3 Phoenix Cart
  by @raiwa
  raiwa@phoenixcartaddons.com
  www.phoenixcartaddons.com

  Copyright (c) 2021: Rainer Schmied

  based on: shipping estimator
  Original version: Edwin Bekaert (edwin@ednique.com)

  CE Phoenix, E-Commerce made Easy
  https://phoenixcart.org

  Copyright (c) 2021 Phoenix Cart

  Released under the GNU General Public License
*/

  class cm_sc_shipping extends abstract_executable_module {

    const CONFIG_KEY_BASE = 'MODULE_CONTENT_SC_SHIPPING_';

    public function __construct() {
      parent::__construct(__FILE__);
    }

    function execute() {
      global $order, $total_count, $total_weight, $db, $Linker, $currencies;

      if (($_SESSION['cart']->count_contents() > 0)) {
        $content_width = (int)MODULE_CONTENT_SC_SHIPPING_CONTENT_WIDTH;

        $selected_shipping = [];

        if (!empty($_SESSION['customer_id'])) {
          $_SESSION['sendto'] = $_SESSION['sendto'] ?? null;
          $order = new order;
          // user is logged in
          if (isset($_POST['address_id'])){
            // user changed address
            $_SESSION['sendto'] = $_POST['address_id'];
            $order->delivery = $GLOBALS['customer']->fetch_to_address($_SESSION['sendto']);
          } elseif ( !empty($_SESSION['sendto']) ) {
            if ( !empty($_SESSION['cart_address_id']) ) {
              // user once changed address
              $_SESSION['sendto'] = $_POST['cart_address_id'] ?? $_SESSION['sendto'];
              } else {
              // first timer
              $_SESSION['sendto'] = $_POST['customer_default_address_id'] ?? $_SESSION['sendto'];
            }
          }
          // set session now
          $_SESSION['cart_address_id'] = $_SESSION['sendto'];
          // set shipping to null ! multipickup changes address to store address...
          $shipping='';
        } else {
          // user not logged in !
          if (!isset($GLOBALS['customer'])) {
            $GLOBALS['customer'] = new class {
              public function fetch_to_address($to = null) {
                return [];
              }
              public function get($key, $to = 0) {
                return null;
              }
              public function get_default_address_id() {
                return null;
              }
              public function get_country_id() {
                return null;
              }
              public function get_zone_id() {
                return null;
              }
           };
          }
          $_SESSION['sendto'] = null;
          if ( isset($_POST['country_id']) ) {
            // country is selected
            $country_info = Country::fetch($_POST['country_id']);
            if ( !empty($_POST['zone_id']) ) {
              $_SESSION['state'] = Zone::fetch_code((int)$_POST['country_id'], (int)$_POST['zone_id'], '');
            } else {
              $_SESSION['state'] = '';
            }
            $order = new order;
            $order->delivery = ['postcode' => ($_POST['zip_code'] ?? MODULE_CONTENT_SC_SHIPPING_DEFAULT_ZIP),
                                    'city' => ($_POST['city'] ?? MODULE_CONTENT_SC_SHIPPING_DEFAULT_CITY),
                                   'state' => $_SESSION['state'],
                                 'country' => ['id' => $_POST['country_id'], 'title' => $country_info['countries_name'], 'iso_code_2' => $country_info['countries_iso_code_2'], 'iso_code_3' =>  $country_info['countries_iso_code_3']],
                              'country_id' => $_POST['country_id'],
                                 'zone_id' => ($_POST['zone_id'] ?? STORE_ZONE),
                               'format_id' => $this->get_address_format_id($_POST['country_id'])];
            $_SESSION['cart_country_id'] = $_POST['country_id'];
            //add state zone_id
            $_SESSION['cart_zone'] = $_POST['zone_id'] ?? STORE_ZONE;
            $_SESSION['cart_zip_code'] = $_POST['zip_code'] ?? MODULE_CONTENT_SC_SHIPPING_DEFAULT_ZIP;
		        $_SESSION['cart_city'] = $_POST['city'] ?? MODULE_CONTENT_SC_SHIPPING_DEFAULT_CITY;
          } elseif ( !empty($_SESSION['cart_country_id']) ) {
            // session is available
            if ( STORE_ZONE != '' ) {
              $_SESSION['state'] = Zone::fetch_code(STORE_ZONE, STORE_COUNTRY, '');
            } else {
              $_SESSION['state'] =  '';
            }
            $country_info = Country::fetch($_SESSION['cart_country_id']);
            $order = new order;
            $order->delivery = ['postcode' => $_SESSION['cart_zip_code'],
                                    'city' => $_SESSION['cart_city'],
                                   'state' => $_SESSION['state'],
                                 'country' => ['id' => $_SESSION['cart_country_id'], 'title' => $country_info['countries_name'], 'iso_code_2' => $country_info['countries_iso_code_2'], 'iso_code_3' =>  $country_info['countries_iso_code_3']],
                              'country_id' => $_SESSION['cart_country_id'],
                               'format_id' => $this->get_address_format_id($_SESSION['cart_country_id']),
                                 'zone_id' => $_SESSION['cart_zone']];
          } else {
            // first timer
            $_SESSION['cart_country_id'] = STORE_COUNTRY;
            $_SESSION['cart_zone'] = STORE_ZONE;
            $_SESSION['cart_zip_code'] = MODULE_CONTENT_SC_SHIPPING_DEFAULT_ZIP;
		        $_SESSION['cart_city'] = MODULE_CONTENT_SC_SHIPPING_DEFAULT_CITY;
            $country_info = Country::fetch(STORE_COUNTRY);
            if ( STORE_ZONE != '' ) {
              $_SESSION['state'] = Zone::fetch_code(STORE_ZONE, STORE_COUNTRY, '');
            } else {
              $_SESSION['state'] =  '';
            }
            $order = new order;
            $order->delivery = ['postcode' => MODULE_CONTENT_SC_SHIPPING_DEFAULT_ZIP,
                                    'city' => MODULE_CONTENT_SC_SHIPPING_DEFAULT_CITY,
                                   'state' => $_SESSION['state'],
                                 'country' => ['id' => STORE_COUNTRY, 'title' => $country_info['countries_name'], 'iso_code_2' => $country_info['countries_iso_code_2'], 'iso_code_3' =>  $country_info['countries_iso_code_3']],
                              'country_id' => STORE_COUNTRY,
                               'format_id' => $this->get_address_format_id($_SESSION['cart_country_id']),
                                 'zone_id' => STORE_ZONE];
          }
          // set the cost to be able to calculate free shipping
          $order->info = ['subtotal' => $_SESSION['cart']->show_total(),
                             'total' => $_SESSION['cart']->show_total(),
                          'currency' => $_SESSION['currency'],
                    'currency_value' => $GLOBALS['currencies']->currencies[$_SESSION['currency']]['value']];
        }

        // weight and count needed for shipping
        $total_weight = $_SESSION['cart']->show_weight();
        $total_count = $_SESSION['cart']->count_contents();
        $shipping_modules = new shipping;
        $quotes = $shipping_modules->quote();
        $order->info['subtotal'] = $_SESSION['cart']->total;
        $order->info['shipping_cost'] = 0;
        // set selections for displaying
        $selected_country = $order->delivery['country']['id'];
        $selected_address = $_SESSION['sendto'];

        $free_shipping = ot_shipping::is_eligible_free_shipping($order->delivery['country_id'], $order->info['total'] - ($order->info['shipping_cost']?? 0));
        $virtual_order = (($_SESSION['cart']->get_content_type() === 'virtual')? true : false);

        $module_count = $shipping_modules->count();
        // begin shipping cost

        if( $free_shipping === false && $_SESSION['cart']->get_content_type() !== 'virtual' ) {
          if (isset($_POST['sid']) && !empty($_POST['sid'])){
            list($module, $method) = explode('_', $_POST['sid']);
            $_SESSION['cart_sid'] = $_POST['sid'];
          } elseif ( !empty($_SESSION['cart_sid']) ) {
            list($module, $method) = explode('_', $_SESSION['cart_sid']);
          } else {
            $module = null;
            $method = null;
          }

          if ( !empty($module) && [] !== $shipping_modules->quote($method, $module) && [] !== $shipping_modules->quote($method, $module)[0]['methods'] ) {
            $selected_quote = $shipping_modules->quote($method, $module);
            if( isset($selected_quote[0]['error'])) {
              if (MODULE_CONTENT_SC_SHIPPING_DEFAULT_SELECT == 'True') {
                $selected_shipping = $shipping_modules->cheapest();
              }
              $order->info['shipping_method'] = $selected_shipping['title'];
              $order->info['shipping_cost'] = $selected_shipping['cost'];
              $order->info['total']+= $selected_shipping['cost'];
            } else {
              $order->info['shipping_method'] = $selected_quote[0]['module'] . (!Text::is_empty($selected_quote[0]['methods'][0]['title'])? ' (' . $selected_quote[0]['methods'][0]['title'] . ')': '' );
              $order->info['shipping_cost'] = $selected_quote[0]['methods'][0]['cost'];
              $order->info['total']+= $selected_quote[0]['methods'][0]['cost'];
              $selected_shipping['title'] = $order->info['shipping_method'];
              $selected_shipping['cost'] = $order->info['shipping_cost'];
              $selected_shipping['id'] = $selected_quote[0]['id'].'_'.$selected_quote[0]['methods'][0]['id'];
            }
          } elseif ($shipping_modules->count() > 0) {
            if (MODULE_CONTENT_SC_SHIPPING_DEFAULT_SELECT == 'True') {
              $selected_shipping = $shipping_modules->cheapest();
            }
            $order->info['shipping_method'] = $selected_shipping['title'] ?? '';
            $order->info['shipping_cost'] = $selected_shipping['cost'] ?? '0';
            $order->info['total']+= $selected_shipping['cost'] ?? '0';
          }
        }
        // virtual products use free shipping
        if ($free_shipping || $virtual_order) {
          $order->info['shipping_method'] = MODULE_CONTENT_SC_SHIPPING_SHIPPING_METHOD_FREE_TEXT . ' ' . MODULE_CONTENT_SC_SHIPPING_SHIPPING_METHOD_ALL_DOWNLOADS;
          $order->info['shipping_cost'] = 0;
          $selected_shipping['id'] = 'free_free';
          $selected_shipping['title'] = MODULE_CONTENT_SC_SHIPPING_SHIPPING_METHOD_FREE_TEXT;
          $selected_shipping['cost'] = 0;
        }
        if (!empty($selected_shipping)) {
          $_SESSION['shipping'] = $selected_shipping;
        } else {
          $_SESSION['shipping']['id'] = '0_0';
        }
        // end of shipping cost
        // end free shipping based on order total

        $tpl_data = [ 'group' => $this->group, 'file' => __FILE__ ];
        include 'includes/modules/content/cm_template.php';

$script = <<<EOL
<script>
  function shipincart_submit(sid){
    if(sid){
      document.estimator.sid.value=sid;
    }
    document.estimator.submit();
    return false;
  }
</script>
EOL;

        $GLOBALS['Template']->add_block($script, 'footer_scripts');
      }
    }

    protected function get_parameters() {
      return [
         'MODULE_CONTENT_SC_SHIPPING_VERSION' => [
          'title' => 'Current Version',
          'value' => '6.3',
          'desc' => 'Version info. It is read only',
          'set_func' => 'cm_sc_shipping::readonly(',
        ],
        'MODULE_CONTENT_SC_SHIPPING_STATUS' => [
          'title' => 'Enable Shipping Estimator Module',
          'value' => 'True',
          'desc' => 'Do you want to add the module to your shop?',
          'set_func' => "Config::select_one(['True', 'False'], ",
        ],
        'MODULE_CONTENT_SC_SHIPPING_CONTENT_WIDTH' => [
          'title' => 'Content Width',
          'value' => '12',
          'desc' => 'What width container should the content be shown in?',
          'set_func' => "Config::select_one(['12', '11', '10', '9', '8', '7', '6', '5', '4', '3', '2', '1'], ",
        ],
        'MODULE_CONTENT_SC_SHIPPING_SORT_ORDER' => [
          'title' => 'Sort Order',
          'value' => '400',
          'desc' => 'Sort order of display. Lowest is displayed first.',
        ],
        'MODULE_CONTENT_SC_SHIPPING_SHOWIC' => [
          'title' => 'Display item count',
          'value' => 'True',
          'desc' => 'Display item count?',
          'set_func' => "Config::select_one(['True', 'False'], ",
        ],
        'MODULE_CONTENT_SC_SHIPPING_SHOWWT' => [
          'title' => 'Display shipping weight',
          'value' => 'True',
          'desc' => 'Display shipping weight?',
          'set_func' => "Config::select_one(['True', 'False'], ",
        ],
        'MODULE_CONTENT_SC_SHIPPING_WTUNIT' => [
          'title' => 'Shipping weight unit',
          'value' => 'lbs',
          'desc' => 'Shipping weight unit.',
        ],
        'MODULE_CONTENT_SC_SHIPPING_SHOWCDD' => [
          'title' => 'Display Country drop-down menu',
          'value' => 'True',
          'desc' => 'Display Country drop-down menu?',
          'set_func' => "Config::select_one(['True', 'False'], ",
        ],
        'MODULE_CONTENT_SC_SHIPPING_SHOWSDD' => [
          'title' => 'Display State drop-down menu',
          'value' => 'False',
          'desc' => 'Display State drop-down menu?',
          'set_func' => "Config::select_one(['True', 'False'], ",
        ],
        'MODULE_CONTENT_SC_SHIPPING_SHOWZDD' => [
          'title' => 'Display Zip Code Input Field',
          'value' => 'False',
          'desc' => 'Display Zip Code Input Field?',
          'set_func' => "Config::select_one(['True', 'False'], ",
        ],
        'MODULE_CONTENT_SC_SHIPPING_SHOWCITY' => [
          'title' => 'Display City Input Field',
          'value' => 'False',
          'desc' => 'Display City Input Field?',
          'set_func' => "Config::select_one(['True', 'False'], ",
        ],
        'MODULE_CONTENT_SC_SHIPPING_SHOWSDD' => [
          'title' => 'Display State drop-down menu',
          'value' => 'False',
          'desc' => 'Display State drop-down menu?',
          'set_func' => "Config::select_one(['True', 'False'], ",
        ],
        'MODULE_CONTENT_SC_SHIPPING_DEFAULT_ZIP' => [
          'title' => 'Default ZIP',
          'value' => '',
          'desc' => 'The dafault Zip Code to show for first time load if \"Display Zip Code\" is enabled.',
        ],
        'MODULE_CONTENT_SC_SHIPPING_DEFAULT_CITY' => [
          'title' => 'Default City',
          'value' => '',
          'desc' => 'The dafault City to show for first time load if \"Display City\" is enabled.',
        ],
        'MODULE_CONTENT_SC_SHIPPING_SHOWUB' => [
          'title' => 'Display Update button',
          'value' => 'True',
          'desc' => 'Display Update button?',
          'set_func' => "Config::select_one(['True', 'False'], ",
        ],
        'MODULE_CONTENT_SC_SHIPPING_DEFAULT_SELECT' => [
          'title' => 'Select cheapest by default',
          'value' => 'False',
          'desc' => 'Shall the cheapest shipping be selected by default?',
          'set_func' => "Config::select_one(['True', 'False'], ",
        ],

      ];
    }

    public static function readonly($value) {
      return $value;
    }

    function get_address_format_id($country_id) {

      $address_format_query = $GLOBALS['db']->query(sprintf(<<<'EOSQL'
SELECT address_format_id AS format_id
  FROM countries
  WHERE countries_id = %s
EOSQL
      , (int)$country_id));

      $address_format = $address_format_query->fetch_assoc();

      return $address_format['format_id'] ?? '1';
    }

  }
